<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en" xml:lang="en">

<head>
  <title>KMacroExpanderBase</title>
  <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
  <meta http-equiv="Content-Style-Type" content="text/css" />
  <link rel="stylesheet" type="text/css" href="../common/doxygen.css" />
  <link rel="stylesheet" media="screen" type="text/css" title="KDE Colors" href="../common/kde.css" />
</head>
<body>
<div id="container">
<div id="header">
  <div id="header_top">
    <div>
      <div>
        <img alt ="" src="../common/top-kde.jpg"/>
        KDE 4.2 PyKDE API Reference
      </div>
    </div>
  </div>
  <div id="header_bottom">
    <div id="location">
      <ul>
        <li>KDE's Python API</li>
      </ul>
    </div>

    <div id="menu">
      <ul>
        <li><a href="../modules.html">Overview</a></li>
<li><a href="http://techbase.kde.org/Development/Languages/Python">PyKDE Home</a></li>
<li><a href="http://kde.org/family/">Sitemap</a></li>
<li><a href="http://kde.org/contact/">Contact Us</a></li>
</ul>
    </div>
  </div>
</div>

<div id="body_wrapper">
<div id="body">
<div id="right">
<div class="content">
<div id="main">
<div class="clearer">&nbsp;</div>

<h1>KMacroExpanderBase Class Reference</h1>
<code>from PyKDE4.kdecore import *</code>
<p>

Subclasses: <a href="../kdecore/KCharMacroExpander.html">KCharMacroExpander</a>, <a href="../kdecore/KWordMacroExpander.html">KWordMacroExpander</a><br />

<h2>Detailed Description</h2>

<p>\class KMacroExpanderBase kmacroexpander.h &lt;KMacroExpanderBase&gt;
</p>
<p>
Abstract base class for the worker classes behind the KMacroExpander namespace
and the KCharMacroExpander and KWordMacroExpander classes.
</p>
<p>

<dl class="author" compact><dt><b>Author:</b></dt><dd> Oswald Buddenhagen &lt;ossi@kde.org&gt; </dd></dl>
</p>
<table border="0" cellpadding="0" cellspacing="0"><tr><td colspan="2"><br><h2>Methods</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj162599820">__init__</a> (self, <a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qchar.html">QChar</a> c=QLatin1Char('%'))</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj187271788">__init__</a> (self, <a href="../kdecore/KMacroExpanderBase.html">KMacroExpanderBase</a> other)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qchar.html">QChar</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj162650892">escapeChar</a> (self)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj162651372">expandEscapedMacro</a> (self, <a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qstring.html">QString</a> str, int pos, <a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qstringlist.html">QStringList</a> ret)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj162599500">expandMacros</a> (self, <a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qstring.html">QString</a> str)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">bool, int (pos)&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj162601900">expandMacrosShellQuote</a> (self, <a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qstring.html">QString</a> str, )</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">bool&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj162601772">expandMacrosShellQuote</a> (self, <a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qstring.html">QString</a> str)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj162650988">expandPlainMacro</a> (self, <a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qstring.html">QString</a> str, int pos, <a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qstringlist.html">QStringList</a> ret)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj162600140">setEscapeChar</a> (self, <a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qchar.html">QChar</a> c)</td></tr>
</table>
<hr><h2>Method Documentation</h2><a class="anchor" name="obj162599820"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname">__init__</td>
<td>(</td>
<td class="paramtype">&nbsp;<em>self</em>, </td>
<td class="paramname"></td>
</tr><tr>
<td class="memname"></td>
<td></td>
<td class="paramtype"><a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qchar.html">QChar</a>&nbsp;</td>
<td class="paramname"><em>c=QLatin1Char('%')</em></td>
</tr>
<tr>
<td></td>
<td>)</td>
<td></td>
<td></td>
<td width="100%"> </td>
</tr></table>
</div>
<div class="memdoc"><p>Constructor.
</p><dl compact><dt><b>Parameters:</b></dt><dd>
<table border="0" cellspacing="2" cellpadding="0">
<tr><td></td><td valign="top"><em>c</em>&nbsp;</td><td> escape char indicating start of macros, or QChar.null for none
</td></tr>
</table></dl>
<p>
</p></div></div><a class="anchor" name="obj187271788"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname">__init__</td>
<td>(</td>
<td class="paramtype">&nbsp;<em>self</em>, </td>
<td class="paramname"></td>
</tr><tr>
<td class="memname"></td>
<td></td>
<td class="paramtype"><a href="../kdecore/KMacroExpanderBase.html">KMacroExpanderBase</a>&nbsp;</td>
<td class="paramname"><em>other</em></td>
</tr>
<tr>
<td></td>
<td>)</td>
<td></td>
<td></td>
<td width="100%"> </td>
</tr></table>
</div>
<div class="memdoc"></div></div><a class="anchor" name="obj162650892"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname"><a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qchar.html">QChar</a> escapeChar</td>
<td>(</td>
<td class="paramtype">&nbsp;</td>
<td class="paramname"><em>self</em>&nbsp;)</td>
<td width="100%"> </td>
</tr>
</table>
</div>
<div class="memdoc"><p>Obtain the macro escape character.
<dl class="return" compact><dt><b>Returns:</b></dt><dd> escape char indicating start of macros, or QChar.null if none
</dd></dl>
</p></div></div><a class="anchor" name="obj162651372"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname">int expandEscapedMacro</td>
<td>(</td>
<td class="paramtype">&nbsp;<em>self</em>, </td>
<td class="paramname"></td>
</tr><tr>
<td class="memname"></td>
<td></td>
<td class="paramtype"><a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qstring.html">QString</a>&nbsp;</td>
<td class="paramname"><em>str</em>, </td>
</tr>
<tr>
<td class="memname"></td>
<td></td>
<td class="paramtype">int&nbsp;</td>
<td class="paramname"><em>pos</em>, </td>
</tr>
<tr>
<td class="memname"></td>
<td></td>
<td class="paramtype"><a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qstringlist.html">QStringList</a>&nbsp;</td>
<td class="paramname"><em>ret</em></td>
</tr>
<tr>
<td></td>
<td>)</td>
<td></td>
<td></td>
<td width="100%"> </td>
</tr></table>
</div>
<div class="memdoc"><p>This function is called every time the escape char is found if it is
not QChar.null. It should determine whether the
string starting at <b>pos</b> witin <b>str</b> is a valid macro and return
the substitution value for it if so.
</p><dl compact><dt><b>Parameters:</b></dt><dd>
<table border="0" cellspacing="2" cellpadding="0">
<tr><td></td><td valign="top"><em>str</em>&nbsp;</td><td> the input string

<tr><td></td><td valign="top"><em>pos</em>&nbsp;</td><td> the offset within <b>str.</b> Note that this is the position of
the occurrence of the escape char

<tr><td></td><td valign="top"><em>ret</em>&nbsp;</td><td> return value: the string to substitute for the macro
</td></tr> </table></dl>
<p> <dl class="return" compact><dt><b>Returns:</b></dt><dd> If greater than zero, the number of chars at <b>pos</b> in <b>str</b>
to substitute with <b>ret</b> (i.e., a valid macro was found). If less
than zero, subtract this value from <b>pos</b> (to skip a macro, i.e.,
substitute it with itself). If zero, scanning continues as if no
escape char was encountered at all.
</dd></dl>
</p></div></div><a class="anchor" name="obj162599500"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname"> expandMacros</td>
<td>(</td>
<td class="paramtype">&nbsp;<em>self</em>, </td>
<td class="paramname"></td>
</tr><tr>
<td class="memname"></td>
<td></td>
<td class="paramtype"><a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qstring.html">QString</a>&nbsp;</td>
<td class="paramname"><em>str</em></td>
</tr>
<tr>
<td></td>
<td>)</td>
<td></td>
<td></td>
<td width="100%"> </td>
</tr></table>
</div>
<div class="memdoc"><p>Perform safe macro expansion (substitution) on a string.
</p>
<p>
</p><dl compact><dt><b>Parameters:</b></dt><dd>
<table border="0" cellspacing="2" cellpadding="0">
<tr><td></td><td valign="top"><em>str</em>&nbsp;</td><td> the string in which macros are expanded in-place
</td></tr>
</table></dl>
<p>
</p></div></div><a class="anchor" name="obj162601900"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname">bool, int (pos) expandMacrosShellQuote</td>
<td>(</td>
<td class="paramtype">&nbsp;<em>self</em>, </td>
<td class="paramname"></td>
</tr><tr>
<td class="memname"></td>
<td></td>
<td class="paramtype"><a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qstring.html">QString</a>&nbsp;</td>
<td class="paramname"><em>str</em>, </td>
</tr>
<tr>
<td></td>
<td>)</td>
<td></td>
<td></td>
<td width="100%"> </td>
</tr></table>
</div>
<div class="memdoc"><p>Perform safe macro expansion (substitution) on a string for use
in shell commands.
</p>
<p>
&lt;h3&gt;*NIX notes&lt;/h3&gt;
</p>
<p>
Explicitly supported shell constructs:
\ '' "" $'' $"" {} () $(()) ${} $() ``
</p>
<p>
Implicitly supported shell constructs:
(())
</p>
<p>
Unsupported shell constructs that will cause problems:
Shortened &amp;quot;&lt;tt&gt;case $v in pat)&lt;/tt&gt;&amp;quot; syntax. Use
&amp;quot;&lt;tt&gt;case $v in (pat)&lt;/tt&gt;&amp;quot; instead.
</p>
<p>
The rest of the shell (incl. bash) syntax is simply ignored,
as it is not expected to cause problems.
</p>
<p>
Note that bash contains a bug which makes macro expansion within
double quoted substitutions (&lt;tt&gt;"${VAR:-%macro}"&lt;/tt&gt;) inherently
insecure.
</p>
<p>
For security reasons, <b>never</b> put expandos in command line arguments
that are shell commands by themselves -
&amp;quot;&lt;tt&gt;sh -c 'foo \%f'&lt;/tt&gt;&amp;quot; is taboo.
&amp;quot;&lt;tt&gt;file=\%f sh -c 'foo "$file"'&lt;/tt&gt;&amp;quot; is OK.
</p>
<p>
&lt;h3&gt;Windows notes&lt;/h3&gt;
</p>
<p>
All quoting syntax supported by KShell is supported here as well.
Additionally, command grouping via parentheses is recognized - note
however, that the parser is much stricter about unquoted parentheses
than cmd itself.
The rest of the cmd syntax is simply ignored, as it is not expected
to cause problems - do not use commands that embed other commands,
though - &amp;quot;&lt;tt&gt;for /f ...&lt;/tt&gt;&amp;quot; is taboo.
</p>
<p>
</p><dl compact><dt><b>Parameters:</b></dt><dd>
<table border="0" cellspacing="2" cellpadding="0">
<tr><td></td><td valign="top"><em>str</em>&nbsp;</td><td> the string in which macros are expanded in-place

<tr><td></td><td valign="top"><em>pos</em>&nbsp;</td><td> the position inside the string at which parsing/substitution
should start, and upon exit where processing stopped
</td></tr> </table></dl>
<p> <dl class="return" compact><dt><b>Returns:</b></dt><dd> false if the string could not be parsed and therefore no safe
substitution was possible. Note that macros will have been processed
up to the point where the error occurred. An unmatched closing paren
or brace outside any shell construct is <b>not</b> an error (unlike in
the function below), but still prematurely terminates processing.
</dd></dl>
</p></div></div><a class="anchor" name="obj162601772"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname">bool expandMacrosShellQuote</td>
<td>(</td>
<td class="paramtype">&nbsp;<em>self</em>, </td>
<td class="paramname"></td>
</tr><tr>
<td class="memname"></td>
<td></td>
<td class="paramtype"><a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qstring.html">QString</a>&nbsp;</td>
<td class="paramname"><em>str</em></td>
</tr>
<tr>
<td></td>
<td>)</td>
<td></td>
<td></td>
<td width="100%"> </td>
</tr></table>
</div>
<div class="memdoc"><p>Same as above, but always starts at position 0, and unmatched closing
parens and braces are treated as errors.
</p></div></div><a class="anchor" name="obj162650988"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname">int expandPlainMacro</td>
<td>(</td>
<td class="paramtype">&nbsp;<em>self</em>, </td>
<td class="paramname"></td>
</tr><tr>
<td class="memname"></td>
<td></td>
<td class="paramtype"><a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qstring.html">QString</a>&nbsp;</td>
<td class="paramname"><em>str</em>, </td>
</tr>
<tr>
<td class="memname"></td>
<td></td>
<td class="paramtype">int&nbsp;</td>
<td class="paramname"><em>pos</em>, </td>
</tr>
<tr>
<td class="memname"></td>
<td></td>
<td class="paramtype"><a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qstringlist.html">QStringList</a>&nbsp;</td>
<td class="paramname"><em>ret</em></td>
</tr>
<tr>
<td></td>
<td>)</td>
<td></td>
<td></td>
<td width="100%"> </td>
</tr></table>
</div>
<div class="memdoc"><p>This function is called for every single char within the string if
the escape char is QChar.null. It should determine whether the
string starting at <b>pos</b> within <b>str</b> is a valid macro and return
the substitution value for it if so.
</p><dl compact><dt><b>Parameters:</b></dt><dd>
<table border="0" cellspacing="2" cellpadding="0">
<tr><td></td><td valign="top"><em>str</em>&nbsp;</td><td> the input string

<tr><td></td><td valign="top"><em>pos</em>&nbsp;</td><td> the offset within <b>str</b>

<tr><td></td><td valign="top"><em>ret</em>&nbsp;</td><td> return value: the string to substitute for the macro
</td></tr> </table></dl>
<p> <dl class="return" compact><dt><b>Returns:</b></dt><dd> If greater than zero, the number of chars at <b>pos</b> in <b>str</b>
to substitute with <b>ret</b> (i.e., a valid macro was found). If less
than zero, subtract this value from <b>pos</b> (to skip a macro, i.e.,
substitute it with itself). If zero, no macro starts at <b>pos.</b>
</dd></dl>
</p></div></div><a class="anchor" name="obj162600140"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname"> setEscapeChar</td>
<td>(</td>
<td class="paramtype">&nbsp;<em>self</em>, </td>
<td class="paramname"></td>
</tr><tr>
<td class="memname"></td>
<td></td>
<td class="paramtype"><a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qchar.html">QChar</a>&nbsp;</td>
<td class="paramname"><em>c</em></td>
</tr>
<tr>
<td></td>
<td>)</td>
<td></td>
<td></td>
<td width="100%"> </td>
</tr></table>
</div>
<div class="memdoc"><p>Set the macro escape character.
</p><dl compact><dt><b>Parameters:</b></dt><dd>
<table border="0" cellspacing="2" cellpadding="0">
<tr><td></td><td valign="top"><em>c</em>&nbsp;</td><td> escape char indicating start of macros, or QChar.null if none
</td></tr>
</table></dl>
<p>
</p></div></div>
</div>
</div>
</div>

<div id="left">

<div class="menu_box">
<div class="nav_list">
<ul>
<li><a href="../allclasses.html">Full Index</a></li>
</ul>
</div>

<a name="cp-menu" /><div class="menutitle"><div>
  <h2 id="cp-menu-project">Modules</h2>
</div></div>
<div class="nav_list">
<ul>
<li><a href="../akonadi/index.html">akonadi</a></li>
<li><a href="../dnssd/index.html">dnssd</a></li>
<li><a href="../kdecore/index.html">kdecore</a></li>
<li><a href="../kdeui/index.html">kdeui</a></li>
<li><a href="../khtml/index.html">khtml</a></li>
<li><a href="../kio/index.html">kio</a></li>
<li><a href="../knewstuff/index.html">knewstuff</a></li>
<li><a href="../kparts/index.html">kparts</a></li>
<li><a href="../kutils/index.html">kutils</a></li>
<li><a href="../nepomuk/index.html">nepomuk</a></li>
<li><a href="../phonon/index.html">phonon</a></li><li><a href="../plasma/index.html">plasma</a></li>
<li><a href="../solid/index.html">solid</a></li>
<li><a href="../soprano/index.html">soprano</a></li>
</ul></div></div>

</div>

</div>
  <div class="clearer"/>
</div>

<div id="end_body"></div>
</div>
<div id="footer"><div id="footer_text">
This documentation is maintained by <a href="&#109;&#97;&#105;&#108;&#116;&#111;&#58;simon&#64;simonzone&#46;com">Simon Edwards</a>.<br />
        KDE<sup>&#174;</sup> and <a href="../images/kde_gear_black.png">the K Desktop Environment<sup>&#174;</sup> logo</a> are registered trademarks of <a href="http://ev.kde.org/" title="Homepage of the KDE non-profit Organization">KDE e.V.</a> |
        <a href="http://www.kde.org/contact/impressum.php">Legal</a>
    </div></div>
</body>
</html>
